/*
**
** Simon Loader ( simon@surf.org.uk)
** $Id$
** This is the code that does the actula work and 
** tries to bind to the ldap server with all the information given
**
*/

#include <stdio.h>
#include <lber.h>
#include <ldap.h>


int pwcheck(char *userid,char *password,char *server,char *base,char *attrib,int port)
{
    LDAP *ld;
    char *dn;


/* Open the LDAP connection.  Change the second argument if your LDAP
   server is not on port 389. */

    if ((ld = ldap_open(server,port)) == NULL)
    {
	/* could contact it something is wrong */
       return 0;
    }

/* Generate a dn to long in as */
	dn = (char *)malloc(strlen(attrib)+strlen(userid)+strlen(base)+3);

    sprintf(dn,"%s=%s,%s",attrib,userid,base);

/* Now bind as the DN with the password supplied earlier...
   Successful bind means the password was correct, otherwise the
   password is invalid. */

    if (ldap_simple_bind_s(ld,dn,password) != LDAP_SUCCESS)
    {
		free(dn);
       ldap_unbind(ld);
	/* couldnt bind therefore username or password wrong */	
       return 0;
    }

	free(dn); 
    ldap_unbind(ld);
    return 1;
}

